Subject: [openpgp] SHA3 algorithm ids.
From: Werner Koch <[email-masked]>
To: [email-masked]
Date: Sat, 08 Aug 2015 11:21:29 +0200
List-Id: "Ongoing discussion of OpenPGP issues." <openpgp.ietf.org>

Hi!

Now that an official SHA3 specs has been published I would like to see
algorithm ids assigned.  Although it is some time until we can publish
rfc-4880bis, it would be useful to agree on the algorithm ids now.
This would be helpful for experimental implementations.  Thus what about
this new table with the SHA2 drop in replacements:

      ID           Algorithm                             Text Name
      --           ---------                             ---------
      1          - MD5 [HAC]                             "MD5"
      2          - SHA-1 [FIPS180]                       "SHA1"
      3          - RIPE-MD/160 [HAC]                     "RIPEMD160"
      4          - Reserved
      5          - Reserved
      6          - Reserved
      7          - Reserved
      8          - SHA256 [FIPS180]                      "SHA256"
      9          - SHA384 [FIPS180]                      "SHA384"
      10         - SHA512 [FIPS180]                      "SHA512"
      11         - SHA224 [FIPS180]                      "SHA224"
      12         - SHA3-224 [FIPS202]                    "SHA3-224"
      13         - SHA3-256 [FIPS202]                    "SHA3-256"
      14         - SHA3-384 [FIPS202]                    "SHA3-384"
      15         - SHA3-512 [FIPS202]                    "SHA3-512"
      100 to 110 - Private/Experimental algorithm

Note that I ordered SHA3-224 first; when we did SHA2 we forgot about 224
and thus it ended up out of order.

I am not sure about the text name.  Is a dash okay (cf. armor header)?

The OIDS are:

   The hexadecimal representations for the
   currently defined hash algorithms are as follows:
    
     [...]  

     - SHA3-224:   0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x07
     - SHA3-256:   0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x08
     - SHA3-384:   0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x09
     - SHA3-512:   0x60, 0x86, 0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x0a

   The ASN.1 Object Identifiers (OIDs) are as follows:

     [...]

     - SHA3-224:   2.16.840.1.101.3.4.2.7
     - SHA3-256:   2.16.840.1.101.3.4.2.8
     - SHA3-384:   2.16.840.1.101.3.4.2.9
     - SHA3-512:   2.16.840.1.101.3.4.2.10

   The full hash prefixes for these are as follows:

       [...]

       SHA3-224:   0x30, 0x51, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
                   0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x07, 0x05,
                   0x00, 0x04, 0x40

       SHA3-256:   0x30, 0x51, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
                   0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x07, 0x05,
                   0x00, 0x04, 0x40

       SHA3-384:   0x30, 0x51, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
                   0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x07, 0x05,
                   0x00, 0x04, 0x40

       SHA3-512:   0x30, 0x51, 0x30, 0x0d, 0x06, 0x09, 0x60, 0x86,
                   0x48, 0x01, 0x65, 0x03, 0x04, 0x02, 0x07, 0x05,
                   0x00, 0x04, 0x40

Shalom-Salam,

   Werner

-- 
Die Gedanken sind frei.  Ausnahmen regelt ein Bundesgesetz.